
from popen2 import popen2, popen3
from Onasys import OnasysDocument
from DAG import DAG

from HTMLgen.HTMLgen import Area, Map, Paragraph, Strong

from string import join

dotprog = "/opt/graphviz/bin/dot"
dotprog = "/export/ldcg_server/ldcg/solaris/bin/dot"
#dotprog = "/cluster/onasysd/cgi/attic/graphviz/bin/dot"

class DAGImage(OnasysDocument):

    def __init__(self, path=None, *args, **kw):
        OnasysDocument.__init__(self, *args, **kw)
        self.valid = {
                       '_no_function' : self.default,
                       'imagemap' : self.imageMap,
                     }
        self.http['Content-type'] = 'text/plain'
        self.path = path
        self.contents = []

    def default(self, cgi):
        self.http['Content-type'] = 'image/gif'
        try:
            jobid=cgi.form['jobid']
        except:
            jobid = self.path

        d = DAG.get(jobid=jobid)
        self.contents = [dotImage(d)]

    def imageMap(self, cgi=None, mapname=None, baseref=""):
        # setting these values isn't all thought out here :P
        if cgi:
            jobid = cgi.form['jobid']
            mapname = cgi.form['name']
            if not baseref:
                baseref = cgi.form['ref']
        else:
            jobid = self.path
            if not mapname:
                mapname = "MAP"

        dag = DAG.get(jobid=jobid)
        dotmap = dotImageMap(dag, baseref)

        thing = Paragraph()
        thing.append(Paragraph("dotmap=%s" % str(dotmap)))
        thing.append(str(dag))
	try:
	    foo = dag.dotSource()
	    pass
	except Exception, e:
	    foo = "Badness: %s" % str(e)
        thing.append(Paragraph(str(foo)))
        thing.append(Paragraph("NODES"))
	for node in dag.nodes():
		thing.append(Paragraph(node.name))

        areas = []

        for line in dotmap.split('\n')[1:]:
            if line:
                fields = line.split(' ')
                coords = join(fields[2:], ' ')
                area = Area(href=fields[1], coords=coords, shape=fields[0])
                areas.append(area)

	if not areas:
            pass
	    self.append(Paragraph(Strong("No ImageMap.  Sorry.  Graphviz version is too old.  Or something.")))

        imagemap = Map(areas=areas, name=mapname)
        self.append(imagemap)

        if not cgi:
            return self

    def __str__(self):
        rv = ""
        for x in self.contents:
            rv += str(x)
        return rv

def dotImage(dag, format="gif", attrs={}):
    attrParams = ""
    for key in attrs.keys():
        attrParams += ' -N%s="%s"' % (key, attrs[key])
    dotout, dotin, doterr = popen3(dotprog+ " -T%s %s" % (format, attrParams))
    #dotout, dotin, doterr = popen3(dotprog+ " -V")
    #dotout, dotin, doterr = popen3("uname -a")
    src = dag.dotSource()
    dotin.write(src)
    dotin.close()
    res = ""
    new = dotout.read()
    err = dotout.read()
    while new:
        res += new
        new = dotout.read()
    return res
    #return res + "\nERR: "+ dotprog + err

def dotImageMap(dag, href=None):
    attrs = {}
    if href:
        attrs = { 'href' : href }
    return dotImage(dag, format="imap", attrs = attrs)

